import es, playerlib, effectlib, gamethread, cPickle, os.path, popuplib, random

### Start Config ###
lasers_on_fire = 0 # If one, a laser will appear whenever a weapon fires, 0 is only when player gets hurt (1 will cause lag probably)
beam_lasts = 0.5 # How many seconds the beams last
victim_lost_points = 0 # If one, the victim will lose points
teamate_attack_lose_points = 1 # If a player attacks a teammate, they lose points
beam_thickness = 35 # How thick the beam is
est_beams = 1 # EST Beams can actually be seen, lol
laser_noise = 0 # How much noise is on the laser
players_in_top = 10 # How many people are in the top
laser_color_t = [255, 0, 0, 255] # The RGB Alpha color that a Terrorist will turn when hit by a laser
laser_color_ct = [0, 0, 255, 255] # The RGB Alpha color that a Counter-Terrorist will turn when hit by a laser
color_delay = 0.5 # Amount of time before the player's color goes back to normal
enable_sounds = 1 # Enable/Disable sounds, 0 is disabled 1 is on player hurt 2 is on weapon fire (if lasers on fire is enabled)
sounds = ['laser.wav', 'zap1.wav']
colors = {
	'2': [255, 0, 0], # The color of Terrorist lasers
	'3': [0, 0, 255] # The color of Counter-Terrorist lasers
}
damage_data = {
	'Crotch': {
		'Points': 25,
		'Freeze': 1,
		'Team Point Loss': 10,
		'Point Loss': 4
	},
	'Head': {
		'Points': 20,
		'Freeze': 2,
		'Team Point Loss': 8,
		'Point Loss': 3
	},
	'Chest': {
		'Points': 15,
		'Freeze': 0.6,
		'Team Point Loss': 6,
		'Point Loss': 2
	},
	'Right Arm': {
		'Points': 7,
		'Freeze': 0.4,
		'Team Point Loss': 3,
		'Point Loss': 1
	},
	'Left Arm': {
		'Points': 7,
		'Freeze': 0.2,
		'Team Point Loss': 3,
		'Point Loss': 1
	},
	'Right Leg': {
		'Points': 5,
		'Freeze': 0.2,
		'Team Point Loss': 3,
		'Point Loss': 1
	},
	'Left Leg': {
		'Points': 5,
		'Freeze': 0.2,
		'Team Point Loss': 3,
		'Point Loss': 1
	}
}
### End Config ###
player_data = {}

hit_groups = {'3': 'Crotch', '1': 'Head', '6': 'Right Leg', '7': 'Left Leg', '5': 'Right Arm', '4': 'Left Arm', '2': 'Chest'}
colors = {'2': [255, 0, 0], '3': [0, 0, 255]}

info = es.AddonInfo() 
info['name']        = "Laser Tag" 
info['version']     = "1.0" 
info['author']      = "Bonbon AKA: Bonbon367" 
info['url']         = "http://addons.eventscripts.com/addons/view/bbank" 
info['description'] = "A new bank with lots of added features" 

es.ServerVar('ltag_version', info['version'], 'LaserTag made by Bonbon AKA Bonbon367').makepublic()

def load():
	player_db = es.getAddonPath('lasertag') + '/players.db'
	if os.path.isfile(player_db):
		global player_data
		players = open(player_db)
		player_data = cPickle.load(players)
		players.close()
	if lasers_on_fire:
		es.doblock('corelib/noisy_on')
	menu = popuplib.easymenu('Laser Tag', '_popup_choice', main_menu)
	config = popuplib.easymenu('Config Values', '_popup_choice', show_config)
	crotch = popuplib.easymenu('Crotch', '_popup_choice', crotch_select)
	head = popuplib.easymenu('Head', '_popup_choice', head_select)
	chest = popuplib.easymenu('Chest', '_popup_choice', chest_select)
	rarm = popuplib.easymenu('Right Arm', '_popup_choice', rarm_select)
	larm = popuplib.easymenu('Left Arm', '_popup_choice', larm_select)
	rleg = popuplib.easymenu('Right Leg', '_popup_choice', rleg_select)
	lleg = popuplib.easymenu('Left Leg', '_popup_choice', lleg_select)
	for a in ['Score', 'Config Values', 'Player Info', 'Top']:
		menu.addoption(a, a)
	for a in damage_data:
		config.addoption(a, a)
	for a in damage_data['Crotch']:
		crotch.addoption(a, '%s - %s'%(a, damage_data['Crotch'][a]))
	for a in damage_data['Head']:
		head.addoption(a, '%s - %s'%(a, damage_data['Head'][a]))
	for a in damage_data['Chest']:
		chest.addoption(a, '%s - %s'%(a, damage_data['Chest'][a]))
	for a in damage_data['Right Arm']:
		rarm.addoption(a, '%s - %s'%(a, damage_data['Right Arm'][a]))
	for a in damage_data['Left Arm']:
		larm.addoption(a, '%s - %s'%(a, damage_data['Left Arm'][a]))
	for a in damage_data['Right Leg']:
		rleg.addoption(a, '%s - %s'%(a, damage_data['Right Leg'][a]))
	for a in damage_data['Left Leg']:
		lleg.addoption(a, '%s - %s'%(a, damage_data['Left Leg'][a]))
	if not es.exists('saycommand', '!linfo'):
		es.regsaycmd('!linfo', 'lasertag/send_menu')
	for a in [crotch, head, chest, rarm, larm, rleg, lleg]:
		a.submenu(0, 'Config Values')
	config.submenu(0, 'Laser Tag')
	add_sounds()

def es_map_start(ev):
	add_sounds()

def unload():
	save_data()
	if lasers_on_fire:
		es.doblock('corelib/noisy_off')
	if es.exists('saycommand', '!linfo'):
		es.unregsaycmd('!linfo')

def send_menu():
	popuplib.send('Laser Tag', es.getcmduserid())

def add_sounds():
	if enable_sounds:
		for sound in sounds:
			es.stringtable('downloadables', 'sound/lasertag/%s'%sound)

def main_menu(userid, choice, popupid):
	if choice == 'Config Values':
		popuplib.send(choice, userid)
	elif choice == 'Player Info':
		player_info_menu = popuplib.easymenu('Player Info', '_popup_choice', player_info_menu_select)
		for userid2 in es.getUseridList():
			player_info_menu.addoption(userid2, playerlib.getPlayer(userid2).get('name'))
		popuplib.send(choice, userid)
		player_info_menu.submenu(0, 'Laser Tag')
	elif choice == 'Top':
		t___t = players_in_top
		top = popuplib.easymenu('Top', '_popup_choice', top_select)
		b = {}
		for l in player_data:
			b[l] = player_data[l]['Points']
		d = sorted(b.iteritems(), key=lambda (k, v): (v, k), reverse=True)
		for e in d:
			t___t -=1
			if t___t >= 0:
				top.addoption(e[0], '%s: %s'%(player_data[e[0]]['Name'], int(player_data[e[0]]['Points'])))
		top.submenu(0, 'Laser Tag')
		popuplib.send(choice, userid)
	elif choice == 'Score':
		es.tell(userid, '#multi', '#greenYou have #Lightgreen%s#green points'%player_data[playerlib.getPlayer(userid).get('steamid')]['Points'])

def show_config(userid, choice, popupid):
	popuplib.send(choice, userid)

def crotch_select(userid, choice, popupid):
	pass

def head_select(userid, choice, popupid):
	pass

def chest_select(userid, choice, popupid):
	pass

def rarm_select(userid, choice, popupid):
	pass

def larm_select(userid, choice, popupid):
	pass

def rleg_select(userid, choice, popupid):
	pass

def lleg_select(userid, choice, popupid):
	pass

def player_info_menu_select(userid, choice, popupid):
	es.tell(userid, '#multi', '#lightgreen%s#green current name #lightgreen%s#green has #lightgreen%s#green points'%(choice, player_data[choice]['Current Name'], player_data[choice]['Points']))
	popuplib.send('Player Info', userid)

def top_select(userid, choice, popupid):
	es.tell(userid, '#multi', '#lightgreen%s#green current name #lightgreen%s#green has #lightgreen%s#green points'%(choice, player_data[choice]['Current Name'], player_data[choice]['Points']))
	popuplib.send('Top', userid)

def save_data():
	player_db = open(es.getAddonPath('lasertag') + '/players.db', 'w')
	cPickle.dump(player_data, player_db)
	player_db.close()

def round_end(ev):
	save_data()

def player_hurt(ev):
	player(ev['attacker']).points(ev['userid'], ev['dmg_health'], ev['hitgroup'])
	if enable_sounds == 1:
		#es.emitsound('player', ev['attacker'], 'lasertag/%s'%random.choice(sounds), 1.0, 0.2)
		es.cexec(ev['attacker'], 'play lasertag/%s'%random.choice(sounds))
	if not lasers_on_fire:
		x, y, z = es.getplayerlocation(ev['userid'])
		x2, y2, z2 = es.getplayerlocation(ev['attacker'])
		r, g, b = colors[str(playerlib.getPlayer(ev['attacker']).get('teamid'))]
		if est_beams:
			es.server.queuecmd('est_effect 3 #a 0 "sprites/lgtning.vmt" %s %s %s %s %s %s %s 1 1 %s %s %s 255'%(x, y, z + 60, x2, y2, z2 + 60, beam_lasts, r, g, b))
		else:
			effectlib.drawLine([x, y, z + 60], [x2, y2, z2 + 60], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", beam_lasts, beam_thickness, beam_thickness, r, g, b, 255, 10, 0, laser_noise, 0, 0)

def bullet_impact(ev):
	x, y, z = es.getplayerlocation(ev['userid'])
	x2, y2, z2 = float(ev['x']), float(ev['y']), float(ev['z'])
	r, g, b = colors[str(playerlib.getPlayer(ev['userid']).get('teamid'))]
	if enable_sounds == 2:
		es.cexec(ev['userid'], 'play lasertag/%s'%random.choice(sounds))
	if est_beams:
		es.server.queuecmd('est_effect 3 #all 0 "sprites/lgtning.vmt" %s %s %s %s %s %s %s 1 1 %s %s %s 255'%(x, y, z + 60, x2, y2, z2, beam_lasts, r, g, b))
	else:
		effectlib.drawLine([x, y, z + 60], [x2, y2, z2 + 60], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", beam_lasts, beam_thickness, beam_thickness, r, g, b, 255, 10, 0, laser_noise, 0, 0)

class player:
	def __init__(self, userid):
		self.userid = userid

	def points(self, victim, dmg, hitgroup):
		global player_data
		if int(self.userid):
			steamid = playerlib.getPlayer(self.userid).get('steamid')
			if not self.userid == victim:
				if self.check_player():
					if not playerlib.getPlayer(self.userid).get('teamid') == playerlib.getPlayer(victim).get('teamid'):
						player_data[steamid]['Points'] += damage_data[hit_groups[hitgroup]]['Points']
						playerlib.getPlayer(victim).set('color', laser_color_t if playerlib.getPlayer(victim).get('teamid') == 2 else laser_color_ct)
						gamethread.delayed(color_delay, playerlib.getPlayer(victim).set, ('color', [255, 255, 255, 255]))
						if damage_data[hit_groups[hitgroup]]['Freeze']:
							playerlib.getPlayer(victim).set('freeze', 1)
							gamethread.delayed(damage_data[hit_groups[hitgroup]]['Freeze'], playerlib.getPlayer(victim).set, ('noclip', 0))
						if victim_lost_points:
							player_data[playerlib.getPlayer(victim).get('steamid')]['Points'] -= damage_data[hit_groups[hitgroup]]['Point Loss']
					elif teamate_attack_lose_points:
						player_data[steamid]['Points'] -= damage_data[hit_groups[hitgroup]]['Team Point Loss']

	def check_player(self):
		if int(self.userid):
			steamid = playerlib.getPlayer(self.userid).get('steamid')
			if not player_data.has_key(steamid):
				global player_data
				player_data[steamid] = {}
				player_data[steamid]['Points'] = 0
				player_data[steamid]['Name'] = playerlib.getPlayer(self.userid).get('name')
				player_data[steamid]['Current Name'] = playerlib.getPlayer(self.userid).get('name')
				es.tell(self.userid, '#multi', '#greenWelcome to our server. #lightgreenLaserTag#green is running, type #lightgreen!linfo#green to see information!')
				return 0
			return 1

	def update_name(self):
		if self.check_player():
			global player_data
			player_data[es.getplayersteamid(self.userid)]['Current Name'] = playerlib.getPlayer(self.userid).get('name')

def player_activate(ev):
	player(ev['userid']).update_name()

def player_changename(ev):
	player(ev['userid']).update_name()
